/*
 功能：基于业务的扩展控件
 作者：冯巧巧
 日期：2017.10.17
 * */
var ecbs = {

    /*（页头）选择组织机构控件*/
    selectorg : function(p) {
        var int_selectedbmId = 0;
        var str_selectuniturl = b.getbasepath() + "winpage/publicbs/selectunit.html";
        var data_units = login.dtUserUnitRightsData || [];

        /*创建框架节点HTML*/
        var makehtml = function() {
            var html = '<div class="ecbs-su"><div class="ub ecbs-su-gs"><div class="fa"></div>';
            html += '<div class="ecbs-su-gs-name ub-f1 xy-fc-green"></div>';
            html += '<div class="fa fa-angle-right xy-fc-green"></div></div>';
            html += '<div style="overflow: auto;"><div class="ecbs-su-bmtemp" style="width: 100em;"></div></div>';
            html += '</div>';

            $(p.selector).html(html);
            $('.ecbs-su-gs', p.selector).on('tap', function() {
                b.show(str_selectuniturl, "winpage_publicbs_selectunit", {
                    pagename : p.pagename,
                    framename : p.framename
                });
            });
        }
        /*创建部门*/
        var makehtml_bm = function(data) {
            var html = "";
            for (var i = 0; i < data.length; i++) {
                html += '<div class="ecbs-su-bm ' + (data[i].I_ID_UNIT == int_selectedbmId ? 'ecbs-su-bm-select' : 'xy-fc-gray') + '" parentid="' + data[i].I_PARENTID + '" btnid="' + data[i].I_ID_UNIT + '">' + data[i].VC_UNITNAME + '</div>';
            };
            $(".ecbs-su-bmtemp", p.selector).html(html);
            $('.ecbs-su-bm', p.selector).on('tap', function() {
                var parentid = this.getAttribute('parentid');
                var btnid = this.getAttribute('btnid');
                $('.ecbs-su-bm', p.selector).removeClass('ecbs-su-bm-select');
                $('.ecbs-su-bm', p.selector).addClass('xy-fc-gray');
                $(this, p.selector).removeClass('xy-fc-gray');
                $(this, p.selector).addClass('ecbs-su-bm-select');
                if (int_selectedbmId != btnid) {
                    if (p.events && p.events.change) {
                        p.events.change(this, parentid, btnid, this.innerHTML);
                    }
                    int_selectedbmId = btnid;
                }
                if (p.events && p.events.click) {
                    p.events.click(this, parentid, btnid, this.innerHTML);
                }
                b.lsset({
                    'ecbs_selectorg_DefaultValue_unit' : btnid,
                    'ecbs_selectorg_DefaultValue_unitname' : this.innerHTML
                });
            });
            dolayout();
        }
        /*优化布局*/
        var dolayout = function() {
            var el_su = $(".ecbs-su",p.selector)[0];
            var el_bmtemp = $(".ecbs-su-bmtemp",p.selector)[0];
            var el_bm = $(".ecbs-su-bm", p.selector);
            var int_suWidth = el_su.offsetWidth;
            var int_bmWidth = 0;
            var int_bmtempWidth = el_bmtemp.offsetWidth;
            for (var i = 0; i < el_bm.length; i++) {
                int_bmWidth += el_bm[i].offsetWidth;
            };
            if (int_bmWidth < int_suWidth) {
                el_bmtemp.style.width = "";
            } else {
                el_bmtemp.style.width = int_bmWidth + "px";
            }
        }
        /*从新加载部门*/
        this.reloadbm = function(unitid) {
            var str_unitname = "";
            var bool_hasunit = false;
            var array_depts = [{
                I_ID_UNIT : '0',
                VC_NO : '003',
                I_PARENTID : unitid,
                VC_UNITNAME : '全部'
            }];
            /*取上次默认选择的公司*/
            int_selectedbmId = b.lsget('ecbs_selectorg_DefaultValue_unit') || '0';

            for (var i = 0; i < data_units.length; i++) {
                /*获取公司信息*/
                if (data_units[i].I_ID_UNIT == unitid) {
                    str_unitname = data_units[i].VC_UNITNAME;
                    $(".ecbs-su-gs-name", p.selector).html(str_unitname);
                }
                /*整理部门*/
                if (data_units[i].VC_NO == '003' && data_units[i].I_PARENTID == unitid) {
                    array_depts.push(data_units[i]);

                    /*查看传入部门ID是否在部门中存在*/
                    if (int_selectedbmId == data_units[i].I_ID_UNIT) {
                        bool_hasunit = true;
                    }
                }
            };

            /*如果之前缓存的部门ID在新公司里面不存在，这个默认设置为 全部 （即0）*/
            if (bool_hasunit == false) {
                int_selectedbmId = 0;
            }

            /*记录下当前选择的公司ID*/
            b.lsset({
                'ecbs_selectorg_DefaultValue_bunit' : unitid,
                'ecbs_selectorg_DefaultValue_bunitname' : str_unitname
            });

            /*创建部门列表*/
            makehtml_bm(array_depts);

            /*触发刷新事件*/
            if (p.events && p.events.refresh) {
                p.events.refresh(this, unitid, int_selectedbmId, str_unitname);
            }
        }
        makehtml();

        /*去上次默认选择的公司*/
        var str_defaultBunitId = b.lsget('ecbs_selectorg_DefaultValue_bunit');
        this.reloadbm(str_defaultBunitId || login.int_loginUnitID);
        ecbs.selectOrgTemp = this;
        return this;
    },

    /*选择推送对象控件*/
    selectpush : function(p) {
        var str_sendUserIds = "";
        var array_sunitIds = [];
        var array_suserIds = [];
        var str_url = pc.SIP;
        var str_selectpushurl = b.getbasepath() + "winpage/publicbs/selectpush.html";
        this.show = function() {
            ecbs.selectpushObj = this;
            b.show(str_selectpushurl, "winpage_publicbs_selectpush", {
                pagename : p.pagename,
                framename : p.framename,
                sunitIds : array_sunitIds,
                suserIds : array_suserIds
            });
        }
        this.doSelect = function(sunitids, suserids, ids, name) {
            array_sunitIds = b.s2j(sunitids);
            array_suserIds = b.s2j(suserids);
            str_sendUserIds = ids;
            if (p.events && p.events.selected) {
                p.events.selected(this, ids, name);
            }
        }
        this.send = function(pi) {
            var me = this;
            if (str_sendUserIds == "") {
                b.alert("没有选择通知对象");
                return;
            }
            b.ajax(str_url, {
                action : "Public.SendPush",
                str_pushUserIds : str_sendUserIds,

                str_bsTableName : pi.tableName,
                str_bsId : pi.bsid,
                str_bsNo : pi.bsNo,

                str_title : pi.title,
                str_params : pi.params,
                str_pushText : pi.pushText
            }, function(state, data) {
                if (state) {
                    if (p.events && p.events.sended) {
                        p.events.sended(me, data.success);
                    }
                }
            });
        }
        return this;
    },

    /*组合输入框控件*/
    groupTextArea : function(p) {
        var me = this,
            obj_timer = null,
            el_frame = $(p.selector).html('<div></div>');
        /*展开或关闭输入框*/
        var fun_openclose = function(node) {
            var el_text = $('textarea', node.parentNode)[0];
            var el_label2 = $('.ecbs-content-label2', node)[0];
            var el_icon = $('.ecbs-content-icon', node);
            if (el_text.style.display == "none") {
                el_text.style.display = "";
                el_label2.innerHTML = "";
                el_icon.removeClass('fa-chevron-down');
                el_icon.addClass('fa-chevron-up');
                setTimeout(function() {
                    el_text.focus();
                }, 500);
            } else {
                el_text.style.display = "none";
                el_label2.innerHTML = el_text.value;
                el_icon.addClass('fa-chevron-down');
                el_icon.removeClass('fa-chevron-up');
            }
        }
        /*创建HTML*/
        var fun_makeel = function() {
            var html = '';
            for (var i = 0; i < p.data.length; i++) {
                var d = p.data[i];
                html += '<div class="ecbs-content" btnid="' + d.id + '">';
                html += '<div class="ub ecbs-content-hd">';
                html += '<div class="ecbs-content-label" notextlabel="' + d.noTextLabel + '">';
                html += d.text;
                html += '</div>';
                html += '<div class="ub-f1 ut-s ecbs-content-label2">';
                html += '</div>';
                html += '<div class="fa fa-chevron-' + (d.expand == true ? 'up' : 'down') + ' ecbs-content-icon"></div>';
                html += '</div>';
                html += '<div class="uinput ub">';
                html += '<textarea placeholder="输入内容" style="display:' + (d.expand == true ? '' : 'none') + ';"></textarea>';
                html += '</div>';
                html += '</div>';
            }
            el_frame.append(html);
            $('.ecbs-content-hd', el_frame).on('tap', function() {
                fun_openclose(this);
            });
        }
        /*启用定时保存功能*/
        var fun_startTimerSave = function() {
            var lsinput = b.lsget(p.timerId);
            if (lsinput && lsinput.length > 0) {
                var json_value = b.s2j(lsinput);
                for (var i in json_value) {
                    me.setValue(json_value[i].id, json_value[i].value);
                }
                b.alert('数据已恢复');
            }
            obj_timer = b.runcycle(function() {
                fun_lsSetInput();
            }, p.timerLength);
        }
        /*缓存输入内容*/
        var fun_lsSetInput = function() {
            var json_value = {},
                bool_hasinput = false;
            for (var i = 0; i < p.data.length; i++) {
                var tid = p.data[i].id;
                var v = b.trim(me.getValue(tid, false));
                if (v.length > 0) {
                    json_value['tid' + tid] = {
                        id : tid,
                        value : v
                    };
                    bool_hasinput = true;
                }
            };
            appcan.locStorage.setVal(p.timerId, bool_hasinput ? b.j2s(json_value) : '');
        }
        /*整理所有输入内容*/
        var fun_getText = function(els, hasTitle) {
            var text = '';
            for (var i = 0; i < els.length; i++) {
                var el_label = $('.ecbs-content-label', els[i])[0];
                var title = el_label.innerHTML;
                var notextlabel = el_label.getAttribute('notextlabel');
                if (notextlabel == 'true') {
                    title = '';
                }
                var value = b.trim($('textarea', els[i]).val());
                if (value.length > 0) {
                    /*换行换行符号*/
                    text += (hasTitle == true ? (title + '\n') : '') + b.trim(value) + '\n';
                }
            };
            return text;
        }
        /*获取输入值*/
        this.getValue = function(id, hasTitle) {
            var str_value = '';
            var els = null;
            hasTitle = (hasTitle == undefined ? true : hasTitle);
            if (id!=undefined||id!=null) {
                els = $('[btnid="' + id + '"]', el_frame);
            } else {
                els = $('.ecbs-content', el_frame);
            }
            str_value = fun_getText(els, hasTitle);
            return str_value;
        }
        /*设置输入值*/
        this.setValue = function(id, value) {
            var els = $('[btnid="' + id + '"]', el_frame);
            $('textarea', els).val(value);
            fun_openclose($('.ecbs-content-hd', els)[0]);
        }
        /*清空表单值*/
        this.clearValue = function() {
            $('textarea', el_frame).val('');
            appcan.locStorage.remove(p.timerId);
            clearInterval(obj_timer);
        }
        /*创建节点*/
        fun_makeel();

        /*启动定时保存*/
        if (p.timerSave) {
            appcan.ready(function() {
                fun_startTimerSave();
            });
        }
        return this;
    },

    /*切换天的工具*/
    changeday : function(p) {
        p = p || {};
        var str_name = "page_winpage_publicbs_changeday" + b.random();
        var str_bodyId = "";
        var str_url = b.getbasepath() + "winpage/publicbs/changeday.html";
        var body = document.body;
        if (body.id) {
            str_bodyId = body.id;
        } else {
            body.id = "id_" + str_name;
            str_bodyId = body.id;
        }
        /*创建工具栏层*/
        var int_bartop = document.body.clientHeight - b.el('nav-left').clientHeight;

        /*设定参数*/
        p.bodyId = str_bodyId;
        p.pagename = str_name;
        b.lsset({
            "showurlparams" : b.j2s(p)
        });
        appcan.frame.open(str_bodyId, str_url, 100000, int_bartop, str_name);

        this.show = function() {
            appcan.frame.resize(str_bodyId, 0, int_bartop, str_name);
            appcan.frame.bringToFront(str_name);
        }
        this.hide = function() {
            appcan.frame.resize(str_bodyId, 100000, int_bartop, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        this.getValue = function() {

        }
        return this;
    },

    /*通用查询*/
    search : function(p) {
        p = p || {};
        var str_name = "winpage_logreport_tools_search";
        var str_bodyId = "";
        var str_url = b.getbasepath() + "winpage/logreport/tools/search.html";
        var body = document.body;
        if (body.id) {
            str_bodyId = body.id;
        } else {
            body.id = "id_" + str_name;
            str_bodyId = body.id;
        }
        p.bodyId = str_bodyId;
        p.pagename = str_name;
        b.lsset({
            "ecbs_search_params" : b.j2s(p)
        });
        appcan.frame.open(str_bodyId, str_url, 100000, 0, str_name);

        this.show = function() {
            appcan.frame.resize(str_bodyId, 0, 0, str_name);
            appcan.frame.bringToFront(str_name);
            b.epscript(p.windowName, str_name, "fun_initSearchValue()");
        }
        this.hide = function() {
            appcan.frame.resize(str_bodyId, 100000, 0, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        return this;
    }
}