/*
 功能：开发、测试阶段需要的一些功能或验证
 作者：FQQ
 日期：2017.09.08
 * */
var testhelper = {

    /*验证插件是否存在*/
    checkUexs : function() {
        /*系统基础插件*/
        var uexsBase = {
            'uexWidget' : true,
            'uexXmlHttpMgr' : true,
            'uexDownloaderMgr' : true,
            'uexFileMgr' : true,
            'uexCall' : false,
            'uexSMS' : false,
            'uexLocation' : false,
            'uexUploaderMgr' : true,
            'uexControl' : false,
            'uexCamera' : true,
            'uexDevice' : false,
            'uexImage':true
        };
        /*其他根据功能选择的插件*/
        var uexsProject = {
            'uexScanner' : true,
            'uexBaiduMap' : false,
            'uexQQ' : true,
            'uexJPush' : true,
            'uexWeiXin' : true
        };
        var str_msg = '';
        for (var i in uexsBase) {
            if (uexsBase[i] && eval('typeof (' + i + ')') == "undefined") {
                str_msg += i + "\n";
            }
        }
        for (var i in uexsProject) {
            if (uexsProject[i] && eval('typeof (' + i + ')') == "undefined") {
                str_msg += i + "\n";
            }
        }
        if (str_msg.length > 3) {
            alert('提示：缺失以下插件\n\n' + str_msg);
        }
    },

    /*开启页面返回功能*/
    startPageback : function() {
        /*关闭初始化页面*/
        $("#page_index").on('longTap', function() {
            appcan.window.close(-1);
        });
        /*关闭首页*/
        $("[class='ut ub-f1 ulev-3 ut-s tx-c'][tabindex='0']").on("longTap", function() {
            appcan.window.close(-1);
        });
    },

    /*验证login.js的引用是否正确*/
    checkLoginJS : function() {
        var scripts = document.getElementsByTagName('script');
        var page = window.location.href.split('/');
        var pageName = page[page.length - 1];
        if (scripts.length > 0) {
            var bool_loadLogin = false;
            var array_iframeJS = ['appcan.js', 'appcan.control.js', 'appcan.listview.js', 'appcan.slider.js', 'appcan.tab.js', 'appcan.treeview.js', 'base.js', 'ec.js', 'pc.js', 'uec.js', 'uf.js', 'appupdate.js', 'reminput.js', 'timertask.js'];
            for (var i = 0; i < scripts.length; i++) {
                if (!bool_loadLogin) {
                    bool_loadLogin = scripts[i].src.split('login.js').length > 1;
                }
                if (bool_loadLogin) {
                    var r = scripts[i].src.split('/');
                    if (b.isin(r[r.length - 1], array_iframeJS)) {
                        alert(pageName + '页面提示\n\nlogin.js需要引用在所有框架JS的后面');
                        return;
                    }
                }
            };
            if (!bool_loadLogin) {
                alert(pageName + '页面提示\n\n缺少login.js的引用');
            }
        }
    }
}
