/*
 功能：系统定时任务列表
 作者：冯巧巧
 日期：2017.08.01
 * */

var timertask = {

    /************************************************************/
    /*定时获取GPS位置并保存*/
    /************************************************************/
    recordGps : function(timer) {

        /*初始化定位插件*/
        var uec_location = uec.location();

        /*打开定位方法(进入页面时先立即保存一次位置信息)*/
        uec_location.open(function(state) {
        }, function(lat, log) {
            uec_location.getAddress(function(address) {
                var json2 = {
                    VC_LONG : log,
                    VC_LAT : lat,
                    VC_ADDR : address
                };
                fun_SaveGps(b.j2s(json2))
                setTimeout(function() {
                    uec_location.close();
                }, 1000);
            });
        });

        
        var fun_getGPSinfo = function() {
            /*打开定位方法*/
            uec_location.open(function(state) {
            }, function(lat, log) {
                /*每次刷新只能定一次*/
                if (b.lsget("bool_isdw") == "false") {
                    uec_location.getAddress(function(address) {
                        var json = {
                            VC_LONG : log,
                            VC_LAT : lat,
                            VC_ADDR : address
                        };
                        fun_SaveGps(b.j2s(json));
                        setTimeout(function() {
                            uec_location.close();
                        }, 1000);
                    });
                    b.lsset({
                        bool_isdw : "true"
                    })
                }
            });
        }
        /*存入GPS信息*/
        var fun_SaveGps = function(json_gps) {
            b.ajax(pc.SIP, {
                action : "Home.SaveGps",
                str_gps : json_gps /*位置信息*/
            }, function(state, data) {
            });
        }
        /*定时刷新获取gps信息*/
        b.runcycle(function() {
            if (login.userId != "0" && login.userId != undefined) {
                b.lsset({
                    bool_isdw : "false"
                })
                fun_getGPSinfo();
            }
        }, timer * 1000);
    }
};
