/*
 功能：基于业务的一些封装方法
 作者：FQQ
 日期：2016.04.22
 **/

/*封装扩展控件 User Function*/
var uf = {

    /*打开通用附件管理*/
    attachment : function(url, tableName, bsId, dataType, ps, userId) {
        var str_windowName = "winpage_attachment_list_" + tableName + bsId;
        var str_frameName = "winpage_attachment_list_content_" + tableName + bsId;
        var p = {
            winName : str_windowName,
            fraName : str_frameName,
            tableName : tableName,
            bsId : bsId,
            dataType : dataType,
            userId : userId
        };
        if (ps) {
            for (var i in ps) {
                p[i] = ps[i];
            }
        }
        b.show(url, str_windowName, p);
    },
    /*打开字典信息进行选择*/
    itemInfo : function(url, itemType, p) {
        var pms = {
            itemType : itemType
        };
        if (p) {
            for (var i in p) {
                pms[i] = p[i];
            }
        }
        b.show(url, "winpage_public_iteminfo", pms);
    },
    /*打开用户信息进行选择*/
    userInfo : function(url, p) {
        b.show(url, "winpage_public_userinfo", p);
    },
    /*打开通用表单控件录入页面*/
    formControl : function(url, control, p) {
        var pms = {
            control : control
        };
        if (p) {
            for (var i in p) {
                pms[i] = p[i];
            }
        }
        b.show(url, "winpage_public_formcontrol", pms);
    },
    /*阴影*/
    menu : function(url, p) {
        p = p || {};
        var str_Id = "frame_winpage_public_menu";
        this.show = function() {
            
            var val = b.j2s(p);
            b.lsset({
                showurlparams : val
            });
            // appcan.locStorage.setVal("showurlparams", b.j2s(p));
            
            appcan.frame.open(str_Id, url, 0, 0, "winpage_public_menu");
        }
    },
    /*弹出等待窗口*/
    waitbox : function(url, p) {
        var str_name = "winpage_public_waitbox";
        var int_width = $('#' + p.bodyId).offset().width + 5000;
        b.lsset({
            waitboxText : p.text || "提交处理中..."
        });
        appcan.frame.open(p.bodyId, url, int_width, 0, str_name);
        this.show = function() {
            appcan.frame.resize(p.bodyId, 0, 0, str_name);
            appcan.frame.bringToFront(str_name);
        }
        this.hide = function() {
            appcan.frame.resize(p.bodyId, int_width, 0, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        return this;
    },
    /*打开支付页面*/
    pay : function(url, p) {
        b.show(url, "winpage_public_paypage", p);
    },
    /*打开分享页面*/
    share : function(url, p) {
        p = p || {};
        var bool_has = false;
        var str_name = "winpage_public_share";
        this.show = function(title, summary, targeturl, imgurl) {
            if (bool_has == false) {
                bool_has = true;
                p.title = title;
                p.summary = summary;
                p.targeturl = targeturl;
                p.imgurl = imgurl;

                var val = b.j2s(p);
                b.lsset({
                    showurlparams : val
                });
                //appcan.locStorage.setVal("showurlparams", b.j2s(p));
                
                appcan.frame.open(p.bodyId, url, 0, 0, str_name);
            } else {
                appcan.frame.resize(p.bodyId, 0, 0, str_name);
                appcan.frame.bringToFront(str_name);
            }
            b.epscript(p.windowName, str_name, "fun_config('" + title + "','" + summary + "','" + targeturl + "','" + imgurl + "')");
        }
        this.hide = function() {
            appcan.frame.resize(p.bodyId, 5000, 0, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        return this;
    },
    timepart : function(url, p) {
        var str_name = "winpage_public_timepart";
        var int_width = $('#' + p.bodyId).offset().width + 5000;

        appcan.frame.open(p.bodyId, url, int_width, 0, str_name);
        this.show = function(str_id, funcName) {
            appcan.frame.resize(p.bodyId, 0, 0, str_name);
            appcan.frame.bringToFront(str_name);
            b.epscript(p.windowName, str_name, "fun_getparam('" + str_id + "','" + funcName + "')");
        }
        this.hide = function() {
            appcan.frame.resize(p.bodyId, int_width, 0, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        return this;
    },
    callsms : function(url, p) {
        p = p || {};
        var str_name = "winpage_public_callsms";
        var int_width = $('#' + p.bodyId).offset().width + 5000;

        appcan.frame.open(p.bodyId, url, int_width, 0, str_name);
        this.show = function(str_phone) {
            appcan.frame.resize(p.bodyId, 0, 0, str_name);
            appcan.frame.bringToFront(str_name);
            b.epscript(p.windowName, str_name, "fun_config('" + str_phone + "')");
        }
        this.hide = function() {
            appcan.frame.resize(p.bodyId, int_width, 0, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        return this;
    },
    popups : function(url, p) {
        p = p || {};
        var str_name = "winpage_public_popups";
        var int_width = $('#' + p.bodyId).offset().width + 5000;

        appcan.frame.open(p.bodyId, url, int_width, 0, str_name);
        this.show = function(aa) {
            appcan.frame.resize(p.bodyId, 0, 0, str_name);
            appcan.frame.bringToFront(str_name);
            b.epscript(p.windowName, str_name, "fun_config('" + aa + "')");
        }
        this.hide = function() {
            appcan.frame.resize(p.bodyId, int_width, 0, str_name);
            appcan.frame.sendToBack(str_name);
        }
        this.close = function() {
            appcan.frame.close(str_name);
        }
        return this;
    }
}